// Generated by CoffeeScript 1.4.0
(function() {
  "use strict";
  var NickMentionedNotification, exports, _ref;

  var exports = (_ref = window.chat) != null ? _ref : window.chat = {};

  /*
   * A notification used when the user's nick is mentioned.
   * Provides functions for determining if a nick was mentioned.
  */


  NickMentionedNotification = (function() {

    function NickMentionedNotification(channel, from, message) {
      this._channel = channel;
      this._from = from;
      this._message = message;
    }

    NickMentionedNotification.prototype.getBody = function() {
      return this._message;
    };

    NickMentionedNotification.prototype.getTitle = function() {
      return "" + this._from + " mentioned you in " + this._channel;
    };

    /*
       * When there are multiple notifications, a list of stubs is displayed from
       * each notification
    */


    NickMentionedNotification.prototype.getStub = function() {
      return "" + this._from + " mentioned you";
    };

    NickMentionedNotification.shouldNotify = function(nick, msg) {
      var msgToTest;
      if (!(nick != null)) {
        return false;
      }
      nick = nick.replace(/_+$/, '');
      nick = this._escapeTextForRegex(nick);
      msgToTest = this._prepMessageForRegex(msg, nick);
      return /\#nick\#_*([!?.]*|[-:;~\*\u0001]?)(?!\S)/i.test(msgToTest);
    };

    NickMentionedNotification._escapeTextForRegex = function(text) {
      return text.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, "\\$&");
    };

    NickMentionedNotification._prepMessageForRegex = function(msg, nick) {
      msg = msg.replace(/,/g, ' ');
      msg = msg.replace(/\#nick\#/gi, 'a');
      msg = msg.replace(new RegExp("@\?" + nick, "ig"), '#nick#');
      /*
           * simulate a negative lookbehind to make sure only whitespace precedes the nick
      */

      return msg.replace(/\S\#nick\#/i, 'a');
    };

    return NickMentionedNotification;

  })();

  exports.NickMentionedNotification = NickMentionedNotification;

}).call(this);
