// Generated by CoffeeScript 1.4.0
(function() {
  "use strict";

  describe("An event emitter", function() {
    var emitter;
    emitter = void 0;
    beforeEach(function() {
      return emitter = new EventEmitter;
    });
    it("emits events to registered listeners", function() {
      var onEat;
      onEat = jasmine.createSpy('onEat');
      emitter.on('eat', onEat);
      emitter.emit('eat', 'burgers');
      return expect(onEat).toHaveBeenCalledWith('burgers');
    });
    it("doesn't emits events to non-registered listeners", function() {
      var onEat;
      onEat = jasmine.createSpy('onEat');
      emitter.on('eat', onEat);
      emitter.emit('cook', 'burgers');
      return expect(onEat).not.toHaveBeenCalledWith('burgers');
    });
    return it("can be listened to for any event", function() {
      var onAny;
      onAny = jasmine.createSpy('onAny');
      emitter.onAny(onAny);
      emitter.emit('drink', 'water');
      emitter.emit('eat', 'burgers');
      expect(onAny).toHaveBeenCalledWith('drink', 'water');
      return expect(onAny).toHaveBeenCalledWith('eat', 'burgers');
    });
  });

}).call(this);
