// Generated by CoffeeScript 1.4.0
(function() {
  "use strict";

  describe("A keyboard shortcut map", function() {
    var map = void 0;
    beforeEach(function() {
      return map = new KeyboardShortcutMap();
    });
    it("maps a keyboard event to a command with certain arguments", function() {
      var ctrl1 = {
        ctrlKey: true,
        which: 49
      };
      var cmd = map.getMappedCommand(ctrl1);
      expect(cmd[0]).toBe('win');
      return expect(cmd[1]).toEqual([1]);
    });
    it("returns an undefined command when the shortcut doesn't match any command", function() {
      var alt1 = {
        altKey: true,
        which: 49
      };
      var cmd = map.getMappedCommand(alt1);
      return expect(cmd[0]).not.toBeDefined();
    });
    it("maps Tab to a command when the input field is empty", function() {
      var tab = {
        which: 9
      };
      var cmd = map.getMappedCommand(tab, "");
      return expect(cmd[0]).toBeDefined();
    });
    return it("doesn't map Tab to a command when the input field isn't empty", function() {
      var tab = {
        which: 9
      };
      var cmd = map.getMappedCommand(tab, "user input");
      return expect(cmd[0]).not.toBeDefined();
    });
  });

}).call(this);
